; sokoban v1.2d
; for Doorsos v0.91Beta
; last release 12/12/98 by Alban Gervaise

        include "sokoban.lvl" ; file where the levels are
        include "graphlib.h"
        include "userlib.h"
        include "doorsos.h"

        xdef _main
        xdef _comment
        xdef _ti89


_main:
level_loop:
        jsr graphlib::clr_scr  ; clear the screen
        bsr ini_level           ; setup the level (decompress and display it)
main_loop:
        bsr info                ; disp the infos of the level (number and status)
        clr.l d2
        clr.l d3
        move.b #1,d5
        jsr userlib::idle_loop     ; wait while a key is pressed
        cmp.w #267,d0           ; if it's ON, turn off calc
        beq off
        cmp.w #264,d0           ; if ESC leave the game
        beq exit
        cmp.w #263,d0           ; if CLEAR restart the level
        beq level_loop
        cmp.w #277,d0           ; if HOME, leave the game
        beq exit
        cmp.w #257,d0           ; if <- undo
        beq back
        cmp.w #43,d0            ; si +, go to the next level
        beq plus
        cmp.w #45,d0            ; si -, go to the last level
        beq moins
        cmp.w #344,d0
        beq go_right
        cmp.w #338,d0
        beq go_left
        cmp.w #337,d0
        beq go_up
        cmp.w #340,d0
        beq go_down
        bra main_loop        

off:
        trap #4                 ; turn off...
        bra main_loop 

go_right:
        move.l #1,d2            ; we want X+1=X
        bsr check               ;
        tst.b d5                ; if d5=0 check is bad so do nothing and return
        beq main_loop           ; 
        move.b (a0),d2          ;
        bsr print_objet         ; disp the sprite at (a0) (old cursor position)
        add.b #4,curX           ;
        move.b (a1),d2          ; disp the sprite at (a1) (now cursor postion)
        bsr print_objet         ;
        add.b #4,curX           ; disp the sprite at (a2) (cursor position + 1)
        move.b (a2),d2          ;
        bsr print_objet         ;
        sub.b #4,curX           ; add 4 to have the good value in curX
        move.b #4,d2            ; 4 in d2 to put the cursor
        bsr print_objet         ;
        bra check_victory       ; check if the level is finished
go_left:                        
        move.l #1,d3
        bsr check
        tst.b d5
        beq main_loop
        move.b (a0),d2
        bsr print_objet
        sub.b #4,curX
        move.b (a1),d2
        bsr print_objet
        sub.b #4,curX
        move.b (a2),d2
        bsr print_objet
        add.b #4,curX
        move.b #4,d2
        bsr print_objet
        bra check_victory
go_up:
        move.l #20,d3
        bsr check
        tst.b d5
        beq main_loop
        move.b (a0),d2
        bsr print_objet
        sub.b #4,curY
        move.b (a1),d2
        bsr print_objet
        sub.b #4,curY
        move.b (a2),d2
        bsr print_objet
        add.b #4,curY
        move.b #4,d2
        bsr print_objet
        bra check_victory
go_down:
        move.l #20,d2
        bsr check
        tst.b d5
        beq main_loop
        move.b (a0),d2
        bsr print_objet
        add.b #4,curY
        move.b (a1),d2
        bsr print_objet
        add.b #4,curY
        move.b (a2),d2
        bsr print_objet
        sub.b #4,curY
        move.b #4,d2
        bsr print_objet
        bra check_victory

check:  
        bsr give_place ; give the different position required (cursor +0,+1,+2)
        cmp.b #1,(a1)  ; if it's a wall: exit
        beq exit        
        cmp.b #0,(a1)  ; if nothing...ok
        beq fin
        cmp.b #3,(a1)  ; if already a place...ok
        beq fin
        cmp.b #2,(a1)  ; if it's a box must look after the box (position +2)
        beq caisse_plus
        move.b (a2),d0 ; here wa have a box and a place
        cmp.b #1,d0    ; if after the box and place there is a wall stop
        beq exit
        cmp.b #2,d0
        beq exit
        cmp.b #5,d0    ; same thing if there is an other bow with a place
        beq exit
        move.b #3,(a1)
        cmp.b #3,d0    ; 
        beq m_e_p_c
        move.b #2,(a2) ; 
        rts
m_e_p_c:
        move.b #5,(a2) ; so change status
        rts
caisse_plus:
        move.b (a2),d0
        cmp.b #1,d0
        beq exit
        cmp.b #2,d0
        beq exit
        cmp.b #5,d0
        beq exit
        move.b (a1),(a2)
        clr.b (a1)
        cmp.b #0,d0
        beq fin
        move.b #5,(a2)
        rts

check_victory:           ; check if there is a box on the level (if no, bingo!)
        move.l #level,a0
        move.w #319,d0
check_loop:
        cmp.b #2,(a0)+   ; if it's a box...it's no good and we stop
        beq main_loop    ; the level is not finished
        dbra d0,check_loop
        tst.b flag       ; if the level has already been won
        bne plus         ; go to the next
        move.l #level,a1
        clr.l d0
        move.b levelnbr,d0
        mulu #82,d0
        lea level1(pc),a0
        add.l #81,d0
        add.l d0,a0      ; if non change its status
        add.b #1,(a0)
plus:   add.b #1,levelnbr
        cmp.b #level_nbr,levelnbr
        bne level_loop
moins:  sub.b #1,levelnbr
        cmp.b #-1,levelnbr
        bne level_loop
        add.b #1,levelnbr
        bra level_loop

give_place:
        clr.l d0
        clr.l d1
        move.b curX,d0
        sub.l #40,d0
        divu #4,d0
        move.b curY,d1
        sub.l #10,d1
        mulu #5,d1
        add.l d1,d0
        move.l #level,a0
        add.l d0,a0
        move.l a0,a1
        add.l d2,a1
        sub.l d3,a1
        move.l a1,a2
        add.l d2,a2
        sub.l d3,a2
        move.l a0,savea0      ; save our position
        move.l a1,savea1      ; to undo it after...
        move.l a2,savea2      ;
        move.b (a0),save0     ;
        move.b (a1),save1     ;
        move.b (a2),save2     ;
        move.b curX,saveX     ;
        move.b curY,saveY     ;
        move.b #1,save        ;
fin:
        rts
back:
        tst.b save            ; we come back and return and old values
        beq main_loop         ; 
        move.l savea0,a0      ;
        move.l savea1,a1      ;
        move.l savea2,a2      ;
        move.b save0,(a0)     ;
        move.b save1,(a1)     ;
        move.b save2,(a2)     ;
        move.b saveX,curX     ;
        move.b saveY,curY     ;
        clr.b save            ; now can't undo (must wait for another action)
        bsr show_level        ; redraw the level
        bra main_loop         ; go to main_loop

info:   
        move.w #0,-(a7)           ;
        jsr doorsos::ST_busy         ;
        pea email(pc)             ; disp my nickname and my e-mail
        jsr doorsos::ST_showHelp     ; 
        move.w #0,-(a7)           ; 
        jsr doorsos::FontSetSys      ;
        move.b levelnbr,d0        ; 
        add.b #1,d0               ;
        lea completed(pc),a0
        move.b #0,-(a0)
        move.w #$2020,-(a0)       ; if >10 so must clear the 1 numbers (otherwise 9 could be 19! for example)
        add.l #2,a0               ;
        clr.l d1
print_loop:
        add.l #1,d1               ; convert the number in a string
        divu #10,d0               ; 
        swap d0                   ;
        add.b #48,d0              ;
        move.b d0,-(a0)           ; 
        clr.w d0                  ;
        swap d0
        tst.w d0
        bne print_loop
        move.w  #4,-(a7)        
        pea level_str(pc)
        move.w #0,-(a7)        
        move.w #0,-(a7)        
        jsr doorsos::DrawStrXY  ; disp level_str with the nomber
        move.l #completed,a0
        move.w #111,d0
        tst.b flag               ; if flag = 0 so "not completed",0
        beq apres
        add.l #4,a0              ; otherwose add 4 for having "completed",0
        move.w #124,d0
apres:
        move.w  #4,-(a7)
        move.l a0,-(a7)
        move.w  #0,-(a7)
        move.w  d0,-(a7)
        jsr     doorsos::DrawStrXY
        lea     28(a7),a7       ; restore the stack 
        rts        

ini_level:
        move.l #level,a1
        clr.l d0
        move.b levelnbr,d0
        mulu #82,d0         
        lea level1(pc),a0   ; a0=level to decompress
        add.l d0,a0
        move.w #6,d3
        move.w #79,d7
loop_comp:
        move.b (a0),d0
        ror.b d3,d0
        and.b #%00000011,d0
        move.b d0,(a1)+
        cmp.w #2,d3
        beq ok_comp
        sub.w #2,d3
        bra loop_comp        
ok_comp:
        move.b (a0)+,d0
        and.b #%00000011,d0
        move.b d0,(a1)+
        move.w #6,d3
        dbra d7,loop_comp
        move.b (a0)+,curX
        move.b (a0)+,curY
        clr.b flag           ; check if the level has already been won
        move.b curY,d0       ;
        divu #4,d0           ;
        swap d0              ;
        cmp.b #2,d0          ;
        beq show_level       ;
        sub.b #1,curY        ;
        move.b #1,flag       ;
show_level:
        move.l #level,a1
        move.w #40,d0
        move.w #10,d1
        move.w #15,d5
        clr.l d2
loop_d1:
        move.w #19,d4        
loop_d0:
        move.b (a1)+,d2
        bsr print_sprite
        add.w #4,d0
        dbra d4,loop_d0
        add.w #4,d1
        move.w #40,d0
        dbra d5,loop_d1

print_curseur:
        move.b #%10010000,d3
        move.w #4,d2
        bra saute_avant
print_objet:
        move.b #%11110000,d3        
saute_avant:
        clr.l d0
        clr.l d1
        move.b curX,d0
        move.b curY,d1
        bra saute
print_sprite:
        move.b #%11110000,d3
saute:
        mulu #8,d2
        move.l #vide,a0
        add.l d2,a0
        jsr graphlib::put_sprite_mask
        rts           
exit:
        clr.l d5
        rts

vide:
        dc.w 4,1
        dc.b 0,0,0,0

brique:
        dc.w 4
        dc.w 1
        dc.b %10100000
        dc.b %01010000
        dc.b %10100000
        dc.b %01010000

caisse:
        dc.w 4
        dc.w 1
        dc.b %11110000
        dc.b %10010000
        dc.b %10010000
        dc.b %11110000

place:
        dc.w 4
        dc.w 1
        dc.b %00000000
        dc.b %01100000
        dc.b %01100000
        dc.b %00000000

curseur:
        dc.w 4
        dc.w 1
        dc.b %01100000
        dc.b %10010000
        dc.b %10010000
        dc.b %01100000

place_caisse:
        dc.w 4
        dc.w 1
        dc.b %11110000
        dc.b %11110000
        dc.b %11110000
        dc.b %11110000

flag    dc.b 0

level_str dc.b "level:   ",0
completed dc.b "not completed",0

levelnbr dc.b 0

curX dc.b 0
curY dc.b 0

savea0 dc.l 0
savea1 dc.l 0
savea2 dc.l 0
save   dc.b 0
save0  dc.b 0
save1  dc.b 0
save2  dc.b 0
saveX  dc.b 0
saveY  dc.b 0

email dc.b "sokoban by Endive GefunS@I-France.com",0

_comment dc.b "Sokoban v1.2d by Endive",0

       BSS

level ds.b 320

 end
