; sokoban v1.2p par by Alban Gervaise
; pour Plusshell v1.0alpha
; derniere modification 12/12/98

        include "sokoban.lvl" ; emplacement des levels

        include "tios.h"
        include "util.h"

        xdef _main
        xdef _comment
        xdef _ti89


_main:
level_loop:
        jsr util::zap_screen    ; efface l'cran
        bsr ini_level           ; initialise le level (dcompresse et affiche)
main_loop:
        bsr info                ; affiche les infos du levels (numro et status)
        clr.l d2
        clr.l d3
        move.b #1,d5
        jsr util::idle_loop     ; on attend qu'une touche soit presse
        cmp.w #267,d0           ; si ON, on eteint
        beq off
        cmp.w #264,d0           ; si ESC, on quitte
        beq exit
        cmp.w #263,d0           ; si CLEAR, on recommence le level
        beq level_loop
        cmp.w #277,d0           ; si HOME, on quitte
        beq exit
        cmp.w #257,d0           ; si <-, on annule le dernier coups
        beq back
        cmp.w #43,d0            ; si +, on va au niveau suprieur
        beq plus
        cmp.w #45,d0            ; si -, on va au niveau infrieur
        beq moins
        cmp.w #344,d0
        beq go_right
        cmp.w #338,d0
        beq go_left
        cmp.w #337,d0
        beq go_up
        cmp.w #340,d0
        beq go_down
        bra main_loop        

off:
        trap #4                 ; on eteint...
        bra main_loop 

go_right:
        move.l #1,d2            ; on veut augmenter X de +1
        bsr check               ;
        tst.b d5                ; si d5=0 le check a chou et on ne fait rien
        beq main_loop           ; 
        move.b (a0),d2          ;
        bsr print_objet        ; on affiche le sprite de (a0) (position)
        add.b #4,curX           ;
        move.b (a1),d2          ; on affiche le sprite de (a1) (position+1)
        bsr print_objet        ;
        add.b #4,curX           ; on affiche le sprite de (a2) (position+2)
        move.b (a2),d2          ;
        bsr print_objet         ;
        sub.b #4,curX           ; remet 4 pour remettre la bonne valeur dans curX
        move.b #4,d2            ; on remet #4 dans d2 car on veut afficher le sprite
        bsr print_objet       ; du curseur
        bra check_victory       ; on regarde si le level est fini
go_left:                        
        move.l #1,d3
        bsr check
        tst.b d5
        beq main_loop
        move.b (a0),d2
        bsr print_objet
        sub.b #4,curX
        move.b (a1),d2
        bsr print_objet
        sub.b #4,curX
        move.b (a2),d2
        bsr print_objet
        add.b #4,curX
        move.b #4,d2
        bsr print_objet
        bra check_victory
go_up:
        move.l #20,d3
        bsr check
        tst.b d5
        beq main_loop
        move.b (a0),d2
        bsr print_objet
        sub.b #4,curY
        move.b (a1),d2
        bsr print_objet
        sub.b #4,curY
        move.b (a2),d2
        bsr print_objet
        add.b #4,curY
        move.b #4,d2
        bsr print_objet
        bra check_victory
go_down:
        move.l #20,d2
        bsr check
        tst.b d5
        beq main_loop
        move.b (a0),d2
        bsr print_objet
        add.b #4,curY
        move.b (a1),d2
        bsr print_objet
        add.b #4,curY
        move.b (a2),d2
        bsr print_objet
        sub.b #4,curY
        move.b #4,d2
        bsr print_objet
        bra check_victory

check:  
        bsr give_place ; donne les valeurs des poistions +0,+1 et +2 en (a0),(a1),(a2)
        cmp.b #1,(a1)  ; si mur on arrete
        beq exit        
        cmp.b #0,(a1)  ; si rien
        beq fin
        cmp.b #3,(a1)  ; ou si emplacement on avance
        beq fin
        cmp.b #2,(a1)  ; si caisse alors on regarde ce qu'il y a derriere
        beq caisse_plus

        move.b (a2),d0 ; ici c'est un emplacement avec une caisse
        cmp.b #1,d0    ; si mur ou caisse, on avance pas
        beq exit
        cmp.b #2,d0
        beq exit
        cmp.b #5,d0    ; si un autre entre emplacement avec caisse on arrete
        beq exit
        move.b #3,(a1)
        cmp.b #3,d0    ; si emplacement 
        beq m_e_p_c
        move.b #2,(a2) ; ici
        rts
m_e_p_c:
        move.b #5,(a2) ; alors devient un emplacement + caisse
        rts
caisse_plus:
        move.b (a2),d0
        cmp.b #1,d0
        beq exit
        cmp.b #2,d0
        beq exit
        cmp.b #5,d0
        beq exit
        move.b (a1),(a2)
        clr.b (a1)
        cmp.b #0,d0
        beq fin
        move.b #5,(a2)
        rts

check_victory:
        move.l #level,a0
        move.w #319,d0
check_loop:
        cmp.b #2,(a0)+   ; si on rencontre une caisse on s'en va 
        beq main_loop    ; le level n'est pas encore termin
        dbra d0,check_loop
        tst.b flag       ; on regarde si le level a dj t gagn
        bne plus         ; si oui alors on va au prochain
        move.l #level,a1
        clr.l d0
        move.b levelnbr,d0
        mulu #82,d0
        lea level1(pc),a0
        add.l #81,d0
        add.l d0,a0      ; si non, on rajoute 1 a curY du level
        add.b #1,(a0)
plus:   add.b #1,levelnbr
        cmp.b #level_nbr,levelnbr
        bne level_loop
moins:  sub.b #1,levelnbr
        cmp.b #-1,levelnbr
        bne level_loop
        add.b #1,levelnbr
        bra level_loop

give_place:
        clr.l d0
        clr.l d1
        move.b curX,d0
        sub.l #40,d0
        divu #4,d0
        move.b curY,d1
        sub.l #10,d1
        mulu #5,d1
        add.l d1,d0
        move.l #level,a0
        add.l d0,a0
        move.l a0,a1
        add.l d2,a1
        sub.l d3,a1
        move.l a1,a2
        add.l d2,a2
        sub.l d3,a2
        move.l a0,savea0      ; sauve la position actuelle
        move.l a1,savea1      ; pour pouvoir ensuite l'annuler
        move.l a2,savea2      ;
        move.b (a0),save0     ;
        move.b (a1),save1     ;
        move.b (a2),save2     ;
        move.b curX,saveX     ;
        move.b curY,saveY     ;
        move.b #1,save        ;
fin:
        rts
back:
        tst.b save            ; on revient en arrire et on remet les
        beq main_loop         ; anciennes valeurs
        move.l savea0,a0      ;
        move.l savea1,a1      ;
        move.l savea2,a2      ;
        move.b save0,(a0)     ;
        move.b save1,(a1)     ;
        move.b save2,(a2)     ;
        move.b saveX,curX     ;
        move.b saveY,curY     ;
        clr.b save            ; on ne peut plus annuler maintenant
        bsr show_level        ; on redessine entirement le level
        bra main_loop         ; on revient  main_loop

info:   
        move.w #0,-(a7)           ;
        jsr tios::ST_busy         ;
        pea email(pc)             ; affiche mon email et eteint
        jsr tios::ST_showHelp     ; l'indicateur de marche
        move.w #0,-(a7)           ; met la petite fonte
        jsr tios::FontSetSys      ;
        move.b levelnbr,d0        ; d0=numero du level
        add.b #1,d0               ;
        lea completed(pc),a0
        move.b #0,-(a0)
        move.w #$2020,-(a0)       ; si >10 alors il faut efface les 2 chiffres sinon pour " 9" ="19"
        add.l #2,a0               ;
        clr.l d1
print_loop:
        add.l #1,d1               ; converti le numro en nombre
        divu #10,d0               ; et le met aprs "level"
        swap d0                   ;
        add.b #48,d0              ;
        move.b d0,-(a0)           ; 
        clr.w d0                  ;
        swap d0
        tst.w d0
        bne print_loop
        move.w  #4,-(a7)        
        pea level_str(pc)
        move.w  #0,-(a7)        
        move.w  #0,-(a7)        
        jsr     tios::DrawStrXY  ; on affiche level_str avec le numro du level
        move.l #completed,a0
        move.w #111,d0
        tst.b flag               ; si flag = 0 alors "not completed",0
        beq apres
        add.l #4,a0              ; sinon on avance de 4 pour faire "completed",0
        move.w #124,d0
apres:
        move.w  #4,-(a7)
        move.l a0,-(a7)
        move.w  #0,-(a7)
        move.w  d0,-(a7)
        jsr     tios::DrawStrXY
        lea     28(a7),a7       ; on restore la stack
        rts        

ini_level:
        move.l #level,a1
        clr.l d0
        move.b levelnbr,d0
        mulu #82,d0         
        lea level1(pc),a0   ; a0=level  dcompress
        add.l d0,a0
        move.w #6,d3
        move.w #79,d7
loop_comp:
        move.b (a0),d0
        ror.b d3,d0
        and.b #%00000011,d0
        move.b d0,(a1)+
        cmp.w #2,d3
        beq ok_comp
        sub.w #2,d3
        bra loop_comp        
ok_comp:
        move.b (a0)+,d0
        and.b #%00000011,d0
        move.b d0,(a1)+
        move.w #6,d3
        dbra d7,loop_comp
        move.b (a0)+,curX
        move.b (a0)+,curY
        clr.b flag           ; vrifie si le level a dj t gagn
        move.b curY,d0       ;
        divu #4,d0           ;
        swap d0              ;
        cmp.b #2,d0          ;
        beq show_level       ;
        sub.b #1,curY        ;
        move.b #1,flag       ;
show_level:
        move.l #level,a1
        move.w #40,d0
        move.w #10,d1
        move.w #15,d5
        clr.l d2
loop_d1:
        move.w #19,d4        
loop_d0:
        move.b (a1)+,d2
        bsr print_sprite
        add.w #4,d0
        dbra d4,loop_d0
        add.w #4,d1
        move.w #40,d0
        dbra d5,loop_d1
print_curseur:
        move.w #4,d2
print_objet:
        clr.l d0
        clr.l d1
        move.b curX,d0
        move.b curY,d1
print_sprite:
        mulu #4,d2
        move.l #vide,a0
        add.l d2,a0
        bsr put_sprite
        rts           
exit:
        clr.l d5
        rts


put_sprite:
        movem d0-d7,-(a7)
        move.w #3,d4
\loop1  move.b (a0)+,d2
        move.b #7,d5
        move.w #3,d3
\loop2  move.w d1,-(a7)
        move.w d0,-(a7)
        btst.b d5,d2
        beq \off
        jsr util::pixel_on
\passe  lea 4(a7),a7
        add.b #1,d0
        sub.b #1,d5
        dbra d3,\loop2
        sub.b #4,d0
        add.b #1,d1
        dbra d4,\loop1
        movem (a7)+,d0-d7
        rts
\off:   jsr util::pixel_off
        bra \passe


vide:
        dc.b 0,0,0,0
brique:
        dc.b %10100000
        dc.b %01010000
        dc.b %10100000
        dc.b %01010000
caisse:
        dc.b %11110000
        dc.b %10010000
        dc.b %10010000
        dc.b %11110000
place:        
        dc.b %00000000
        dc.b %01100000
        dc.b %01100000
        dc.b %00000000
curseur:
        dc.b %01100000
        dc.b %10010000
        dc.b %10010000
        dc.b %01100000
place_caisse:
        dc.b %11110000
        dc.b %11110000
        dc.b %11110000
        dc.b %11110000


flag    dc.b 0

level_str dc.b "level:   ",0
completed dc.b "not completed",0

levelnbr dc.b 0

curX dc.b 0
curY dc.b 0

savea0 dc.l 0
savea1 dc.l 0
savea2 dc.l 0
save   dc.b 0
save0  dc.b 0
save1  dc.b 0
save2  dc.b 0
saveX  dc.b 0
saveY  dc.b 0

email dc.b "sokoban by Endive GefunS@I-France.com",0

_comment dc.b "Sokoban v1.2p by Endive",0

       BSS

level ds.b 320

 end

; par Alban Gervaise
